;
; openSE by maq
;

bits 32

global _ColorSub
global _ColorAdd
global _ColorBlend

section .data

align 16

section .text
align 16

_ColorBlend:
; formula
; b+((alpha*(a-b))>>8)

    push ebp
    mov ebp,esp

    pushad

    mov edx, [ebp+8]       ; destination
    mov edi, [ebp+12]      ; color1
    mov esi, [ebp+16]      ; color2
	mov ecx, [ebp+24]      ; dwords

	pxor mm6, mm6          ; makes mm6 == 0

	; fixes alpha to word aligment
    movd mm7, [ebp+20]
	pslld mm7, 8
	paddusb mm7, [ebp+20]
	pslld mm7, 8
	paddusb mm7, [ebp+20]
	punpcklbw mm7, mm6

align 16
             
    .loop
		movd mm0,[esi]          ;pixels a
		movd mm1,[edi]          ;pixels b
		punpcklbw mm0,mm6       ;byte-->word(pixel 1)
		punpcklbw mm1,mm6       ;byte-->word(pixel 1)
		psubw mm0,mm1           ;a-b
		pmullw mm0,mm7          ;pixel 1 * alpha
		psrlw mm0,8             ;shifts word elements 8 to the right.
		paddb mm0,mm1           ;add (b) to result
		packuswb mm0,mm6        ;convert back into byte form
		movd [edx],mm0

        add esi,4
        add edi,4
		add edx,4
        dec ecx
        jnz .loop

    emms

    popad
    
    pop ebp
    ret

_ColorAdd:

    push ebp
    mov ebp,esp

    pushad

    mov edx, [ebp+8]       ; destination
    mov edi, [ebp+12]      ; color1
    mov esi, [ebp+16]      ; color2
	mov ecx, [ebp+20]      ; dwords
	shr ecx, 1

align 16
             
    .loop
		movq mm0, [edi]
		movq mm1, [esi]
		paddusb mm0,mm1
		movq [edx],mm0

        add esi,8
        add edi,8
		add edx,8
        dec ecx
        jnz .loop

    emms

    popad
    
    pop ebp
    ret

_ColorSub:

    push ebp
    mov ebp,esp

    pushad

    mov edx, [ebp+8]       ; destination
    mov edi, [ebp+12]      ; color1
    mov esi, [ebp+16]      ; color2
	mov ecx, [ebp+20]      ; dwords
	shr ecx, 1

align 16
             
    .loop
		movq mm0, [edi]
		movq mm1, [esi]
		psubusb mm0,mm1
		movq [edx],mm0

        add esi,8
        add edi,8
		add edx,8
        dec ecx
        jnz .loop

    emms

    popad
    
    pop ebp
    ret
