#include "..\include\converter.h"
#include "..\include\openSE.h"

void Convert32_32rgb888( void *src, void *dst, int pixels )
{
	mmx_memcpy( dst, src, pixels*4 );

/*	#ifdef __PTC_MEMCPY__
		memcpy( dst, src, pixels*4 );
	#else
		int32 *p = (int32*)src;
		int32 *q = (int32*)dst;
		while( pixels-- )
		{
			*(q++) = *(p++);
		}
	#endif
*/
}

void Convert32_32bgr888( void *src, void *dst, int pixels )
{
	dword_ *p = (dword_*)src;
	dword_ *q = (dword_*)dst;
	while (pixels--)
	{
		dword_ r = (dword_)( (*p & 0x00FF0000) >> 16 );
		dword_ g = (dword_)( (*p & 0x0000FF00) );
		dword_ b = (dword_)( (*p & 0x000000FF) << 16 );
		*(q++) = r | g | b;
	}
}

void Convert32_24rgb888( void *src, void *dst, int pixels )
{
	Convert32_24rgb888mmx( dst, src, pixels );

/*	char8 *p = (char8*)src;
	char8 *q = (char8*)dst;
	while( pixels-- )
	{
		*q = *p;
		*(q+1) = *(p+1);
		*(q+2) = *(p+2);
		p+=4;
		q+=3;
	}
*/
}

void Convert32_24bgr888( void *src, void *dst, int pixels )
{
	byte_ *p = (byte_*)src;
	byte_ *q = (byte_*)dst;
	while( pixels-- )
	{
		*(q+2) = *p;
		*(q+1) = *(p+1);
		*q = *(p+2);
		p+=4;
		q+=3;
	}
}

void Convert32_16rgb565( void *src, void *dst, int pixels )
{
	Convert32_16rgb565mmx( dst, src, pixels );

/*	int32 *p = (int32*)src;
	short16 *q = (short16*)dst;
	while( pixels-- )
	{
		short16 r = (short16)( (*p & 0x00F80000) >> 8 );
		short16 g = (short16)( (*p & 0x0000FC00) >> 5 );
		short16 b = (short16)( (*p & 0x000000F8) >> 3 );
		*q = r | g | b;
		p++;
		q++;
	}
*/
}

void Convert32_16bgr565( void *src, void *dst, int pixels )
{
	Convert32_16bgr565mmx( dst, src, pixels );

/*	int32 *p = (int32*)src;
	short16 *q = (short16*)dst;
	while( pixels-- )
	{
		short16 r = (short16)( (*p & 0x00F80000) >> 19 );
		short16 g = (short16)( (*p & 0x0000FC00) >> 5  );
		short16 b = (short16)( (*p & 0x000000F8) << 8  );
		*q = r | g | b;
		p++;
		q++;
	}
*/
}

void Convert32_16rgb555( void *src, void *dst, int pixels )
{
	Convert32_16rgb555mmx( dst, src, pixels );

/*	int32 *p = (int32*)src;
	short16 *q = (short16*)dst;
	while( pixels-- )
	{
		short16 r = (short16) ( (*p & 0x00F80000) >> 9 );
		short16 g = (short16) ( (*p & 0x0000F800) >> 6 );
		short16 b = (short16) ( (*p & 0x000000F8) >> 3 );
		*q = r | g | b;
		p++;
		q++;
	}
*/
}

void Convert32_16bgr555( void *src, void *dst, int pixels )
{
	Convert32_16rgb555mmx( dst, src, pixels );

/*	int32 *p = (int32*)src;
	short16 *q = (short16*)dst;
	while( pixels-- )
	{
		short16 r = (short16)( (*p & 0x00F80000) >> 20 );
		short16 g = (short16)( (*p & 0x0000F800) >> 6  );
		short16 b = (short16)( (*p & 0x000000F8) << 8  );
		*q = r | g | b;
		p++;
		q++;
	}
*/
}

